
#ifndef MATRIX_H
#define MATRIX_H

#include <vector>
#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/serialization/serialization.hpp>
#include <boost/serialization/access.hpp>
#include <boost/serialization/vector.hpp>

#include "Block.h"

using namespace std;
using namespace boost;
using namespace serialization;

class Matrix {

public:
	Matrix(){};

	Matrix(int mSize);

	static Matrix init(int mSize, int bSize, double val);

	void multiply(Matrix matrix1, Matrix matrix2);

	void print();

private:
	int N;
	std::vector< std::vector< Block* > > data;

	friend class::serialization::access;

	template<class Archive>
	void serialize(Archive & ar, const unsigned int version) {
		ar & N;
		ar & data;
	}
};

#endif
